//+------------------------------------------------------------------+
//|                                                     Receiver.mq4 |
//|                                      Copyright 2017, nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, nicholishen"
#property link      "https://www.forexfactory.com/nicholishen"
#property version   "1.00"
#property strict


#include <stdlib.mqh>
#include <Arrays\ArrayLong.mqh>
#include <Arrays\ArrayString.mqh>

#define EVENT_ONTICK  1
#define __ERROR__       printf("<!!!> %s:: %s",__FUNCTION__,ErrorDescription(_LastError));
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
ulong g_time;

int OnInit()
{
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   for(long ch=ChartFirst();ch>=0;ch=ChartNext(ch))
   {
      if(ch == ChartID())
         continue;
      g_time = GetMicrosecondCount();
      if(!EventChartCustom(ch,EVENT_ONTICK,ChartID(),0.0,_Symbol))
         __ERROR__
      else 
         break;
   }
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   static ulong ping=0, max=0, min=LONG_MAX, cnt=0, avg=0;
   if(id == CHARTEVENT_CUSTOM+EVENT_ONTICK)
   {
      ping = GetMicrosecondCount()-g_time;
      if(ping > max)
         max = ping;
      if(ping < min)
         min = ping;
      avg+=ping;
      cnt++;
      
      printf("ping = %d, min = %d, max = %d, avg = %d",
             ping, min, max, avg/cnt);
   }
}
//+------------------------------------------------------------------+
